Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | Protected Member Functions | List of all members
stk::UdpSocket Class Reference

STK UDP socket server/client class. More...

`#include <UdpSocket.h>`

Inheritance diagram for stk::UdpSocket:

## Public Member Functions

| UdpSocket (int port=2006)
| Default constructor creates a local UDP socket on port 2006 (or the specified port number).
| ~UdpSocket ()
| The class destructor closes the socket instance.
void | setDestination (int port=2006, std::string hostname="localhost")
| Set the address for subsequent outgoing data sent via the writeBuffer() function.
int | writeBuffer (const void *buffer, long bufferSize, int flags=0)
| Send a buffer to the address specified with the setDestination() function. Returns the number of bytes written or -1 if an error occurs.
int | readBuffer (void *buffer, long bufferSize, int flags=0)
| Read an input buffer, up to length bufferSize. Returns the number of bytes read or -1 if an error occurs.
int | writeBufferTo (const void *buffer, long bufferSize, int port, std::string hostname="localhost", int flags=0)
| Write a buffer to the specified socket. Returns the number of bytes written or -1 if an error occurs.
Public Member Functions inherited from stk::Socket
| Socket ()
| Class constructor.
virtual | ~Socket ()
| Class destructor.
int | id (void) const
| Return the socket descriptor.
int | port (void) const
| Return the socket port number.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Protected Member Functions

void | setAddress (struct sockaddr_in *address, int port=2006, std::string hostname="localhost")
| A protected function for use in writing a socket address structure.
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Additional Inherited Members

Static Public Member Functions inherited from stk::Socket
static void | close (int socket)
| Close the socket.
static bool | isValid (int socket)
| Returns true if the socket descriptor is valid.
static void | setBlocking (int socket, bool enable)
| If enable = false, the socket is set to non-blocking mode. When first created, sockets are by default in blocking mode.
static int | writeBuffer (int socket, const void *buffer, long bufferSize, int flags)
| Write a buffer via the specified socket. Returns the number of bytes written or -1 if an error occurs.
static int | readBuffer (int socket, void *buffer, long bufferSize, int flags)
| Read a buffer via the specified socket. Returns the number of bytes read or -1 if an error occurs.
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64

## Detailed Description

STK UDP socket server/client class.

This class provides a uniform cross-platform UDP socket server/client interface. Methods are provided for reading or writing data buffers. The constructor creates a UDP socket and binds it to the specified port. Note that only one socket can be bound to a given port on the same machine.

UDP sockets provide unreliable, connection-less service. Messages can be lost, duplicated, or received out of order. That said, data transmission tends to be faster than with TCP connections and datagrams are not potentially combined by the underlying system.

The user is responsible for checking the values returned by the read/write methods. Values less than or equal to zero indicate the occurence of an error.

by Perry R. Cook and Gary P. Scavone, 1995–2023.

## Constructor & Destructor Documentation

## ◆ UdpSocket()

stk::UdpSocket::UdpSocket | ( | int | port = 2006 | ) |

Default constructor creates a local UDP socket on port 2006 (or the specified port number).

An StkError will be thrown if a socket error occurs during instantiation.

## Member Function Documentation

## ◆ setDestination()

void stk::UdpSocket::setDestination | ( | int | port = 2006,
|  | std::string | hostname = "localhost" )

Set the address for subsequent outgoing data sent via the writeBuffer() function.

An StkError will be thrown if the host is unknown.

## ◆ writeBuffer()

int stk::UdpSocket::writeBuffer | ( | const void * | buffer,
|  | long | bufferSize,
|  | int | flags = 0 )

virtual

Send a buffer to the address specified with the setDestination() function. Returns the number of bytes written or -1 if an error occurs.

This function will fail if the default address (set with setDestination()) is invalid or has not been specified.

Implements stk::Socket.

## ◆ setAddress()

void stk::UdpSocket::setAddress | ( | struct sockaddr_in * | address,
|  | int | port = 2006,
|  | std::string | hostname = "localhost" )

protected

A protected function for use in writing a socket address structure.

An StkError will be thrown if the host is unknown.

The documentation for this class was generated from the following file:

- UdpSocket.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.